<?php
/*------------------------------------------------------------------------
# com_odudeprofile - ODude Profile
# ------------------------------------------------------------------------
# author    ODude Network
# copyright Copyright (C) 2014 ODude.com. All Rights Reserved.
# License GNU GPL
# Website: http://www.odude.com
-------------------------------------------------------------------------*/
// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe = JFactory::getApplication();
jimport( 'joomla.plugin.plugin' );

/**
 * Example system plugin
 */
class plgSystemODudeProfile extends JPlugin
{
	/**
	 * Constructor
	 *
	 * For php4 compatibility we must not use the __constructor as a constructor for plugins
	 * because func_get_args ( void ) returns a copy of all passed arguments NOT references.
	 * This causes problems with cross-referencing necessary for the observer design pattern.
	 *
	 * @access	protected
	 * @param	object	$subject The object to observe
	 * @param 	array   $config  An array that holds the plugin configuration
	 * @since	1.0
	 */
 function plgSystemODudeProfile( &$subject, $config )
	{
		parent::__construct( $subject, $config );

		// Do some extra initialisation in this constructor if required
	}

  function profileUpdate($username)
  {
  //Updating record if it is not created
  
 		       $db =JFactory::getDBO();
 		        $user = JFactory::getUser($username);
 		       
          $qr="select * from #__odude_profile where id=".$user->id;
           $dbc = JFactory::getDBO();
		        $dbc->setQuery( $qr );
           $rows_p = $dbc->loadObjectList();
           
           if(empty($rows_p))
           {
           
            $qrc="select * from #__odude_profile_setting where id=1";
           $dbc1 = JFactory::getDBO();
		      $dbc1->setQuery( $qrc );
           $sett = $dbc->loadObjectList();
           $point= $sett[0]->bonuspt;
           $days= $sett[0]->bonusdays;
           
          
           $query="INSERT INTO `#__odude_profile` (`id`, `facebook_id`, `pic`, `point`) VALUES ('".$user->id."', '', '', 0);";
           $db->setQuery($query);
           $result = $db->query();
            $sp=plgSystemODudeProfile::doProfilePoint('admin',$username,$point,'BONUS',$days);
           }
           
           $qr="select * from #__odude_profile_data where aid=".$user->id;
           $dbc = JFactory::getDBO();
		        $dbc->setQuery( $qr );
           $rows_p = $dbc->loadObjectList();
           
           if(empty($rows_p))
           {
            
           
           $query="INSERT INTO `#__odude_profile_data` (`dataid`, `aid`, `block`) VALUES (NULL, '".$user->id."', '0');";
           $db->setQuery($query);
           $result = $db->query();
           }
  }


       function getProfilePoint($username)
		{

		//plgSystemODudeProfile::profileUpdate($username);

          $qr="select * from #__odude_profile where id=(select id from #__users where username='".$username."')";
           $dbc = JFactory::getDBO();
		   $dbc->setQuery( $qr );
           $rows_p = $dbc->loadObjectList();
           
           if(!empty($rows_p))
           {
              
                                      
            return $rows_p[0]->point;
 		       }
 		       else
 		       {
 		              
 		       
 		       return -1;
 		       }
      }
       function getProfileExpire($username)
		{

          $qr="select * from #__odude_profile where id=(select id from #__users where username='".$username."')";
           $dbc = JFactory::getDBO();
		   $dbc->setQuery( $qr );
           $rows_p = $dbc->loadObjectList();
           if(!empty($rows_p))
           {
           return $rows_p[0]->exp_date;
 		       }
 		       else
 		       {
 		       return -1;
 		       }
      }
      
    function getPointCheck($from,$cost)
		{
		$params = JComponentHelper::getParams( 'com_odudeprofile' );
    //$component = JComponentHelper::getComponent( 'com_odudeprofile' );
   // $params = new JParameter( $component->params );
   
    
		    $sp=plgSystemODudeProfile::getProfilePoint($from);
		    $spDate=plgSystemODudeProfile::getProfileExpire($from);
		    $exp_date = $spDate;
        $todays_date = date("Y-m-d");
        
        if($spDate!=-1)
        {
        $today = strtotime($todays_date);
        $expiration_date = strtotime($exp_date);
             //Checking Expire Date
              if ($expiration_date > $today)
               {
                   //Checking points
                        if($cost>$sp)
                		    {
                          JError::raiseNotice( 100, JText::_('COM_ODUDE_NO_FUND')." <a  href='".$params->get( 'pointurl' )."' >".JText::_('COM_ODUDE_RECHARGE')."</a>" );
                          return '0';
                        }
                        else
                        {
                          //JError::raiseNotice( 100, JText::_('COM_ODUDE_OK'));
                          return '1';
                        }
                   //END Point
              } else 
              {
                   JError::raiseNotice( 100, JText::_('COM_ODUDE_EXPIRED')." ".$spDate." <a  href='".$params->get( 'pointurl' )."' >".JText::_('COM_ODUDE_RECHARGE')."</a>" );
                   return '0';
              }
              //End Expire
		     }
		    
		    
		    
		
		}
      
      
      function doProfilePoint($from,$to,$point,$msg,$days)
		{

           $sp=plgSystemODudeProfile::getProfilePoint($from);
           
           //To check if receiver profile is in database or not
           $rec=plgSystemODudeProfile::getProfilePoint($to);
           plgSystemODudeProfile::profileUpdate($to);
           plgSystemODudeProfile::profileUpdate($from);
           $user = JFactory::getUser($to);
             jimport('joomla.utilities.date');
                  $date = new JDate;
           
           /*       
           if($rec==-1)
                {
                 $db2 =& JFactory::getDBO();
                $query2="INSERT INTO `#__odude_profile` (`id`, `point`,`exp_date`) VALUES ('".$user->id."', '0','".$date->toSql()."')";
                $db2->setQuery($query2);
                $result = $db2->query();
                }
            */      
                  
           $db2 = JFactory::getDBO();
                $query2="update `#__odude_profile` set `exp_date`='".$date->toSql()."' where exp_date<now() and id='".$user->id."'";
                $db2->setQuery($query2);
                $result = $db2->query(); 
                       
           if($sp>=$point || ($from=='admin' && $to=='admin'))
           {
               
                 if($point!='x')
               {
                 
                  
                $url = $_SERVER['SERVER_NAME'];
                $page = $_SERVER['PHP_SELF'];
                $url = "http://".$url.$page;
                $file = $_SERVER['REQUEST_URI'];
                

                $db2 = JFactory::getDBO();
                $query2="INSERT INTO `#__odude_profile_point` (`id` ,`ffrom` ,`tto` ,`point` ,`days`,`type`,`date`,`url`)VALUES (NULL , '$from', '$to', '$point','$days', '$msg','".$date->toSql()."','$url.$file')";
                $db2->setQuery($query2);
                $result = $db2->query();
                
                //if($from!='admin' && $to!='admin')
                //{
                $query2="update `#__odude_profile` set point=point-$point where id=(select id from #__users where username='".$from."')";
                $db2->setQuery($query2);
                $result = $db2->query();
               // }
                
                if($days>=0)
                {
                $query2="update `#__odude_profile` set point=point+$point,exp_date=DATE_ADD(exp_date, INTERVAL $days DAY) where id=(select id from #__users where username='".$to."')";
                $db2->setQuery($query2);
                $result = $db2->query();
                }
                if($days<0)
                {
                $query2="update `#__odude_profile` set point=point+$point,exp_date=DATE_SUB(exp_date, INTERVAL -$days DAY) where id=(select id from #__users where username='".$to."')";
                $db2->setQuery($query2);
                $result = $db2->query();
                }
                if($from=='admin' && $to=='admin')
                {
                $query2="update `#__odude_profile` set point=point+$point where id=(select id from #__users where username='".$from."')";
                $db2->setQuery($query2);
                $result = $db2->query();
                }

                
                }

                return 'COM_ODUDEPROFILE_OK_POINT';
           }
           else
           {
               return 'COM_ODUDEPROFILE_NO_FUND';

           }


      }
	
       function getProfilePic($type,$data,$size)
		{
         $odude_profile=JPATH_ROOT.DS.'components'.DS.'com_odudeprofile'.DS;
         jimport('joomla.html.parameter');
if (file_exists($odude_profile."odudeprofile.php"))
{

 $params = JComponentHelper::getParams( 'com_odudeprofile' );
   //$component = JComponentHelper::getComponent( 'com_odudeprofile' );
  //$params = new JParameter( $component->params );
  $mymenuitem = $params->get('mymenuitem');
 
            $id=0;
            $username='';
            $abc=0;

        if($type=='email')
        {
           $qr="select id,username,name from #__users where email='".$data."'";
           $dbc = JFactory::getDBO();
		   $dbc->setQuery( $qr );
           $rows_p = $dbc->loadObjectList();
           if($rows_p)
           {
           $id=$rows_p[0]->id;
           $username= $rows_p[0]->username;
           $name= $rows_p[0]->name;
           $abc=1;
           }

         }
         else
         {
           $qr="select id,username,name from #__users where username='".$data."'";
           $dbc = JFactory::getDBO();
		   $dbc->setQuery( $qr );
           $rows_p = $dbc->loadObjectList();
           if($rows_p)
           {
           $id=$rows_p[0]->id;
           $username= $rows_p[0]->username;
            $name= $rows_p[0]->name;
           $abc=1;
           }
         }
        
        if($abc==1)
        {
        $pic="select pic from #__odude_profile where id=".$id;
        $dbc = JFactory::getDBO();
		$dbc->setQuery( $pic );
        $rows_p = $dbc->loadObjectList();
         if($rows_p)
         {
              if (preg_match("/http/i", $rows_p[0]->pic))
              {
                 if (($file = @file_get_contents($rows_p[0]->pic)))
                 {

                  if($size=='icon')
                  {
                   echo  "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&user=".$id)."' ><img src='".$rows_p[0]->pic."' id=card2 width=75 width=75 alt=\"".$name."\" title=\"".$name."\"></a>";
                   }
                  else if($size=='micro')
                  {
                   echo  "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&user=".$id)."' ><img src='".$rows_p[0]->pic."' id=card2 width=25 width=25 alt=\"".$name."\" title=\"".$name."\"></a>";
                   } 
                   else
                   {
                   echo  "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&user=".$id)."' ><img src='".$rows_p[0]->pic."' id=card2 alt=\"".$name."\" title=\"".$name."\"></a>";
                   }
                 }
                 else
                 {
                 $db =  JFactory::getDBO();
                 $query = "update #__odude_profile set pic=0 WHERE id = ".$db->Quote($id);

		        //$db->setQuery($query);
		        //$db->query();
				   echo "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&usr=".$id)."' ><img src='".JURI::root()."components/com_odudeprofile/uploads/user.gif' id=card2  alt=\"".$name."\" title=\"".$name."\"></a>";
               }
              }
              else
              {

              $thumb1_path="media/odudeprofile/icon_".$rows_p[0]->pic;
                 if (file_exists($thumb1_path))
                 {
                      if($size=='icon')
                      echo "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&usr=".$id)."' ><img src='".JURI::root()."media/odudeprofile/".$size."_".$rows_p[0]->pic."' id=card2 width=75 width=75 alt=\"".$name."\" title=\"".$name."\" ></a>";
                      else if($size=='micro')
                      echo "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&usr=".$id)."' ><img src='".JURI::root()."media/odudeprofile/".$size."_".$rows_p[0]->pic."' id=card2 width=25 width=25 alt=\"".$name."\" title=\"".$name."\" ></a>"; 
                      else
                      echo "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&usr=".$id)."' ><img src='".JURI::root()."media/odudeprofile/".$size."_".$rows_p[0]->pic."' id=card2 alt=\"".$name."\" title=\"".$name."\" ></a>";
                   }
                 
                 else
                 {
                        if($size=='icon')
                        echo "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&usr=".$id)."' ><img src='".JURI::root()."components/com_odudeprofile/uploads/user.gif' id=card2 width=75 width=75 alt=\"".$name."\" title=\"".$name."\"></a>";
                         else if($size=='micro')
                         echo "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&usr=".$id)."' ><img src='".JURI::root()."components/com_odudeprofile/uploads/user.gif' id=card2 width=25 width=25 alt=\"".$name."\" title=\"".$name."\"></a>";
                         else
                        echo "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&usr=".$id)."' ><img src='".JURI::root()."components/com_odudeprofile/uploads/user.gif' id=card2 alt=\"".$name."\" title=\"".$name."\"></a>";
                 }
              }
           }
           else
           {
            echo "<a href='".JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username."&usr=".$id)."' ><img src='".JURI::root()."components/com_odudeprofile/uploads/user.gif' id=card2  alt=\"".$name."\" title=\"".$name."\"></a>";
           }
           }
         }
   }
         
    function ODudeMail($data,$mail,$size,$sub,$message)
		{
  $odude_profile=JPATH_ROOT.DS.'components'.DS.'com_odudeprofile'.DS;
if (file_exists($odude_profile."odudeprofile.php"))
{
 $params = JComponentHelper::getParams( 'com_odudeprofile' );
 //  $component = JComponentHelper::getComponent( 'com_odudeprofile' );
 // $params = new JParameter( $component->params );
  $mymenuitem = $params->get('mymenuitem');
            $id=0;
            $username='';
            $abc=0;


           $qr="select id,username,name,email from #__users where username='".$data."'";
           $dbc = JFactory::getDBO();
		   $dbc->setQuery( $qr );
           $rows_p = $dbc->loadObjectList();
           if($rows_p)
           {
           $id=$rows_p[0]->id;
           $username= $rows_p[0]->username;
            $name= $rows_p[0]->name;
            $email= $rows_p[0]->email;
           $abc=1;
           }

        $userpic="";
         $u = JURI::getInstance();
         $user = JFactory::getUser();
        $color=$params->get( 'a2' );
                             $from = $params->get( 'from' );
							  $fromname = $user->name;
							  $recipient = $mail;
						      $subject = $sub;
							  $replyto = $params->get( 'replyto' );
				              $replytoname = $user->name;
				              $mode = 1;
				              
         $header="<font style=\'font:normal 10px verdana;color:#666666\'>".JText::_('COM_ODUDEPROFILE_MAIL_BECAUSE')." ".$u->getHost()." </font><table width=500 border=0 cellpadding=0 cellspacing=1 style=\'border-top:1px solid $color;border-left:1px solid $color;border-right:1px solid $color;border-bottom:1px solid $color\'><tr><td align=center bgcolor=$color><font style=\'font:bold 11px tahoma;color:#FFFFFF\'>".$sub."</font></td></tr><tr><td align=left>";

         $footer="</td></tr></table>";

         
         
        if($abc==1)
        {
        $pic="select pic from #__odude_profile where id=".$id;
        $dbc = JFactory::getDBO();
		$dbc->setQuery( $pic );
        $rows_p = $dbc->loadObjectList();
         if($rows_p)
         {
              if (preg_match("/http/i", $rows_p[0]->pic))
              {
                 if($size=='icon')
                 {
                  $userpic="<a href='".$u->getScheme()."://".$u->getHost().JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username)."' ><img src='".$rows_p[0]->pic."' id=card2 width=75 width=75 alt=\"".$name."\" title=\"".$name."\"></a>";
                 }
                 else
                 {
                 $userpic="<a href='".$u->getScheme()."://".$u->getHost().JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username)."' ><img src='".$rows_p[0]->pic."' id=card2 alt=\"".$name."\" title=\"".$name."\"></a>";
                 }
              }
              else
              {

              $thumb1_path="media/odudeprofile/icon_".$rows_p[0]->pic;
                 if (file_exists($thumb1_path))
                 {

                 $userpic="<a href='".$u->getScheme()."://".$u->getHost().JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username)."' ><img src='".JURI::root()."media/odudeprofile/".$size."_".$rows_p[0]->pic."' id=card2 alt=\"".$name."\" title=\"".$name."\" ></a>";
                 }
                 else
                 {
                 $userpic="<a href='".$u->getScheme()."://".$u->getHost().JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username)."' ><img src='".JURI::root()."components/com_odudeprofile/uploads/user.gif' id=card2 width=75 alt=\"".$name."\" title=\"".$name."\"></a>";
                 }
              }
           }
           else
           {

            $userpic="<a href=\'".$u->getScheme()."://".$u->getHost().JRoute::_("index.php?option=com_odudeprofile&view=user&Itemid=".$mymenuitem."&id=".$username)."\' ><img src=\'".JURI::root()."components/com_odudeprofile/uploads/user.gif\' width=75 alt=\'$name\' title=\'$name\'></a>";
           }
           }
           
           $db = JFactory::getDBO();
           $msg=$header."<table border=0><tr><td>".$userpic."</td><td>".$message."</td></tr></table>".$footer;


           //     	   JUtility::sendMail($from, $fromname, $recipient, $subject, $msg, $mode,'','','',$replyto, $replytoname);
           $mailer = JFactory::getMailer();
           $config = JFactory::getConfig();
           $sender = array(
           $config->get( $fromname ),
           $config->get( $from ) );

           $mailer->setSender($sender);
           $user = JFactory::getUser();
           //$recipient = $user->email;
           //$recipient = array( 'person1@domain.com', 'person2@domain.com', 'person3@domain.com' );
           $mailer->addRecipient($recipient);
           $mailer->setSubject($subject);
           $mailer->setBody($msg);
           $mailer->isHTML(true);
           // Optional file attached
           //$mailer->addAttachment(JPATH_COMPONENT.DS.'assets'.DS.'document.pdf');
           // Optionally add embedded image
           //$mailer->AddEmbeddedImage( JPATH_COMPONENT.DS.'assets'.DS.'logo128.jpg', 'logo_id', 'logo.jpg', 'base64', 'image/jpeg' );

           try
           {
           $send = $mailer->Send();
           }
           catch (Exception $e)
           {
            echo 'Caught exception: ',  $e->getMessage(), "\n";
           }
           //if ( $send !== true )
           // {
           //echo 'Error sending email: ' . $send->message;
           //}



         }

     }


}
