<?php

/*------------------------------------------------------------------------
# com_odudeprofile - ODude Profile
# ------------------------------------------------------------------------
# author    ODude Network
# copyright Copyright (C) 2014 ODude.com. All Rights Reserved.
# License GNU GPL
# Website: http://www.odude.com
-------------------------------------------------------------------------*/
// no direct access
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );


class odudeprofileModeluser extends JModelLegacy
{

    function getFields()
    {

		   $db = JFactory::getDBO();
			$query = "select * from #__odude_profile_field where published=1 order by ordering";
			$db->setQuery($query);
			$rows = $db -> loadObjectList();
			return $rows;

    }
     function getData($parms)
    {
      $id=JRequest::getVar('id', '0');
		  $db = JFactory::getDBO();
			$query = "select * from #__odude_profile_data where aid=(select id from #__users where username='$id')";
			$db->setQuery($query);
			$rows = $db -> loadObjectList();
			if(!empty($rows))
			return $rows[0]->$parms;
			else
			return '';

    }


    function getCard($id)
	{
		$profile = array();
		$db = JFactory::getDBO();
		$query =  "select * from #__users where username='".$id."'";
		$db->setQuery($query);
		$rows = $db -> loadObjectList();
      $user_data = $db->loadObject();

      if($user_data)
      {
      
      function convert_datetime($str)
     {

    list($date, $time) = explode(' ', $str);
    list($year, $month, $day) = explode('-', $date);
    list($hour, $minute, $second) = explode(':', $time);

    $timestamp = mktime($hour, $minute, $second, $month, $day, $year);

    return $timestamp;
    }
    
      function timeAgo($timestamp, $granularity=2, $format='Y-m-d H:i:s')
      {
       // $difference = time() - $timestamp;
      // $user = JFactory::getUser();
         $mainframe = JFactory::getApplication();

        //echo $user->getParam('timezone');
        //echo $mainframe->getCfg('offset');
          
        $difference = date(time()-((60*60)*$mainframe->getCfg('offset'))) - $timestamp;
       if($difference < 0) return '0 seconds';             // if difference is lower than zero check server offset
        elseif($difference < 864000)
        {                                   // if difference is over 10 days show normal time form

                $periods = array(JText::_('COM_ODUDEPROFILE__WEEK') => 604800,JText::_('COM_ODUDEPROFILE__DAY') => 86400,JText::_('COM_ODUDEPROFILE__HR') => 3600,JText::_('COM_ODUDEPROFILE__MIN') => 60,JText::_('COM_ODUDEPROFILE__SEC') => 1);
                $output = '';
                foreach($periods as $key => $value)
                {

                        if($difference >= $value)
                        {

                                $time = round($difference / $value);
                                $difference %= $value;

                                $output .= ($output ? ' ' : '').$time.' ';
                                $output .= (($time > 1 && $key == 'day') ? $key.'s' : $key);

                                $granularity--;
                        }
                        if($granularity == 0) break;
                }
                return ($output ? $output : '0 seconds');
        }
        else return date($format, $timestamp);
        }


        
        
        $profile['username']=$rows[0]->username;

	   $profile['name']=$rows[0]->name;
	   $profile['registerDate']=$rows[0]->registerDate;
	   $profile['lastvisitDate']=$rows[0]->lastvisitDate;

	   $profile['lastvisitDateUNIX']=convert_datetime($rows[0]->lastvisitDate);
	   $profile['lastvisitDateAGO']= timeAgo($profile['lastvisitDateUNIX']);
	    $profile['id']=$rows[0]->id;
	    //$profile['usertype']=$rows[0]->usertype;
		$profile['usertype']='';
         $profile['email']=$rows[0]->email;

      }
      else
      {
        $profile['username']="x";
      
      }


	return $profile;
	}
	
	function getDetail($id)
	{
		$profile = array();
		$db = JFactory::getDBO();
		$query =  "select * from #__odude_profile where id='".$id."'";
		$db->setQuery($query);
		$rows = $db -> loadObjectList();
      $user_data = $db->loadObject();

      if($user_data)
      {

		$profile['picORG']=$rows[0]->pic;
		$profile['point']=$rows[0]->point;

		
       if (preg_match("/http/i", $rows[0]->pic))
        {
    $profile['pic']="<img src='".$rows[0]->pic."' id=card2>";
    }
    else
     {

   $thumb1_path="media/odudeprofile/icon_".$rows[0]->pic;
   if (file_exists($thumb1_path))
   {
      $profile['pic']="<img src='".JURI::root()."media/odudeprofile/thumb_".$rows[0]->pic."' id=card2>";
   }
   else
   {
     $profile['pic']="<img src='".JURI::root()."components/com_odudeprofile/uploads/user.gif' id=card2>";
   }
   

    }
		

      }
      else
      {
       $profile['pic']="<img src='".JURI::root()."components/com_odudeprofile/uploads/user.gif' id=card2>";
      
      }
      
      	$query =  "select * from #__session where userid='".$id."'";
		$db->setQuery($query);
		$rows = $db -> loadObjectList();
      $user_data = $db->loadObject();
       if($user_data)
      {

        $profile['online']='Online';
        
        }
        else
        {
          $profile['online']='Offline';
        }


	return $profile;
	}
	



}
